struct descriptor_32 page_aligned xen_gdt[8192];
struct vcpu_guest_context page_aligned xen_ctxt;

struct shared_info page_aligned shared_info = {
    .vcpu_info[0] = {
	.evtchn_upcall_mask    = 1,
    },
};

int grant_frames;
struct grant_entry page_aligned grant_table[GRANT_ENTRIES];

uint64_t gdt_mfn[16];

/* statistics */
uint64_t emu_hcalls[XEN_HCALL_MAX];
uint64_t emu_mcalls[XEN_HCALL_MAX];
uint64_t emu_faults[XEN_FAULT_MAX];
